const nodes = [
    {
      "id": "A",
      "label": "Sahas"
    },
    {
      "id": "B",
      "label": "Smaran"
    },
    {
      "id": "C",
      "label": "Abhi"
    },
    {
      "id": "D",
      "label": "Rahul"
    },
    {
      "id": "E",
      "label": "Jaideep"
    },
    {
      "id": "F",
      "label": "Tarun"
    },
    {
      "id": "G",
      "label": "Bhargav"
    },
    {
      "id": "H",
      "label": "Pavan"
    },
    {
      "id": "I",
      "label": "Naveen"
    },
    {
      "id": "J",
      "label": "Harsha"
    }
  ];

const links = [

    {
      "source": "A",
      "target": "B"
    },
    {
      "source": "A",
      "target": "E"
    },
    {
      "source": "B",
      "target": "F"
    },

    {
      "source": "B",
      "target": "C"
    },
            {
      "source": "C",
      "target": "E"
    }
    ,

    {
      "source": "C",
      "target": "D"
    },
     {
      "source": "H",
      "target": "C"
    }
    ,
    {
      "source": "D",
      "target": "E"
    }
    ,

    {
      "source": "D",
      "target": "I"
    },
    {
      "source": "E",
      "target": "J"
    }
  ];


// Create the D3.js simulation
const simulation = d3.forceSimulation(nodes)
    .force("link", d3.forceLink(links).id(d => d.id).distance(100))
    .force("charge", d3.forceManyBody().strength(-800))
    .force("center", d3.forceCenter(400, 340));

// Create the SVG elements for links and nodes
const svg = d3.select("#graph");
const linkGroup = svg.append("g").attr("class", "links");
const nodeGroup = svg.append("g").attr("class", "nodes");

// Create links
const linksSelection = linkGroup.selectAll("line")
    .data(links)
    .enter()
    .append("line")
    .attr("stroke", "black");

// Create nodes
const nodesSelection = nodeGroup.selectAll("circle")
    .data(nodes)
    .enter()
    .append("circle")
    .attr("r", 30)
    .attr("fill", "lightblue");

// Add node labels
const labelsSelection = nodeGroup.selectAll("text")
    .data(nodes)
    .enter()
    .append("text")
    .text(d => d.label)
    .attr("text-anchor", "middle")
    .attr("dy", 5)
    .attr("font-size", "16px");

// Render function to position the elements during simulation
function render() {
    linksSelection
        .attr("x1", d => d.source.x)
        .attr("y1", d => d.source.y)
        .attr("x2", d => d.target.x)
        .attr("y2", d => d.target.y);

    nodesSelection
        .attr("cx", d => d.x)
        .attr("cy", d => d.y);

    labelsSelection
        .attr("x", d => d.x)
        .attr("y", d => d.y);
}

// Call the render function on each tick of the simulation
simulation.on("tick", render);
